/**********************************************************************************************
 *****************      FINAL PROJECT IN NEURAL NETWORKS -- CS 5388     ***********************
 *****************                 by: Karan M. Gupta                   ***********************
 **********************************************************************************************
 *****************        Bidirectional Associative Memory Storage      ***********************
 *****************                  Lecture 9, Pg 8                     ***********************
 **********************************************************************************************/

void BAM()
{

  cout << endl << "************        Bidirectional Associative Memory Storage       ************";
  cout << endl << "************                   Lecture 9, Pg 8                     ************" << endl;

  const int n = 6;                          // no. of elements in a vector "a"
  const int m = 3;                          // no. of elements in a vector "b"
  const int P = 4;                          // no. of vectors in a set

  typedef CWTSVector<n> Vectora;
  typedef CWTSVector<m> Vectorb;
  typedef CWTSMatrix<n, m> Matrixw;
  typedef CWTSMatrix<m, n> Matrixwt;

  int i, j, p, cycleno, k=0;
  int norows;
  char probe;
  double sum;

  /**** Results: *************************************************************************
   **** This implementation of the BAM algorithm uses the example given in the notes.
   **** The user may input different values in the vectors to test the algorithm.
   ***************************************************************************************/

  Vectora a[P];                             // array "A" of input patterns
  a[0][0] = 1; a[0][1] = 1; a[0][2] = 1; a[0][3] = 1; a[0][4] = 1; a[0][5] = 1;
  a[1][0] = -1; a[1][1] = -1; a[1][2] = -1; a[1][3] = -1; a[1][4] = -1; a[1][5] = -1;
  a[2][0] = 1; a[2][1] = 1; a[2][2] = -1; a[2][3] = -1; a[2][4] = 1; a[2][5] = 1;
  a[3][0] = -1; a[3][1] = -1; a[3][2] = 1; a[3][3] = 1; a[3][4] = -1; a[3][5] = -1;

  Vectorb b[P];                             // array "B" of input patterns
  b[0][0] = 1; b[0][1] = 1; b[0][2] = 1;
  b[1][0] = -1; b[1][1] = -1; b[1][2] = -1;
  b[2][0] = 1; b[2][1] = -1; b[2][2] = 1;
  b[3][0] = -1; b[3][1] = 1; b[3][2] = -1;

  Vectora x;                        // our probe vector is of type "A"
  x.Fill(1); x[0] = -1;             // probe vector

  char choice, c;
  for (i = 0; i < P; i++)
    {
      cout << endl << "Vector A" << i+1; 
      iprint(": ", a[i]);
    }
  for (i = 0; i < P; i++)
    {
      cout << endl << "Vector B" << i+1; 
      iprint(": ", b[i]);
    }
  iprint("\nGiving Probe Vector: ", x);
  cout << endl << "Do you want to use the default values? (y/n): ";
  cin >> choice;
  if ((choice == 'n') || (choice == 'N'))
    {
      cout << endl << "Preparing to accept values from the user...";
      cout << endl << "The original values are shown in parenthesis." << endl;
      for (i = 0; i < P; i++)
	for (j = 0; j < n; j++)
	  {
	    cout << "Enter value for A" << i+1 << " " << j << " (" << a[i][j] << "): ";
	    cin >> a[i][j];
	  }
      for (i = 0; i < P; i++)
	for (j = 0; j < m; j++)
	  {
	    cout << "Enter value for B" << i+1 << " " << j << " (" << b[i][j] << "): ";
	    cin >> b[i][j];
	  }
      cout << endl << "Enter details for the probe vector:";
      cout << endl << "A or B? : ";
      cin >> probe;
      if ((probe == 'A') || (probe == 'a'))
	norows = n;
      else
	norows = m;
      for (i = 0; i < norows; i++)
	{
	  cout << "X" << i+1 << " (" << x[i] << "): ";
	  cin >> x[i];
	}
    }

  Matrixw w;                                      // weight matrix W
  w.Fill(0);                                      // init W with zeroes.
  // Calculate the values that go into the Weight Matrix
  for (i = 0; i < n; i++)
    for (j = 0; j < m; j++)
      {
	sum = 0;
	for (p = 0; p < P; p++)
	  sum += a[p][i] * b[p][j];
	w[i][j] = sum;
      }
  cout << "w: " << endl << w;

  Matrixwt wt;                                   // Transpose of W
  wt = transpose(w);
  cout << "wT: " << endl << wt;

  // TESTING the memory
  Vectora tempa;
  cout << endl << "Testing by inputting b3 and trying to retreive a3:";
  tempa = w * b[2];
  for (i = 0; i < n; i++)
    tempa[i] = sgn(tempa[i]);
  cout << endl << "The result is: " << endl << tempa;
  if (tempa == a[2])
    cout << "a3 has been correctly retreived.";
  else
    cout << "Unable to retreive a3.";

  Vectorb tempb;
  cout << endl << "Testing by inputting a1 and trying to retreive b1:" << endl;
  tempb = wt * a[0];
  for (i = 0; i < m; i++)
    tempb[i] = sgn(tempb[i]);
  cout << endl << "The result is: " << endl << tempb;
  if (tempb == b[0])
    cout << "b1 has been correctly retreived.";
  else
    cout << "Unable to retreive b1.";

  // RETREIVAL PHASE
  //  Vectora x;
  //x.Fill(1); x[0] = -1;
  iprint("\nGiving Probe: ", x);
  cycleno = 0;
  Vectora aO, nexta; 
  Vectorb bO, nextb;
  switch(x.GetRows())
    {
    case n:
      // The vector library restricts programming around the static allocation 
      // of memory to the vector datatype.
      // To test the retreival using a vector of type "B", just comment the next line
      aO = x;
      bO.Fill(0);
      while(1)
	{
	  cycleno++;
	  cout << endl << "Cycle no.: " << cycleno;
	  nextb = wt * aO;
	  for (i = 0; i < m; i++)
	    nextb[i] = sgn(nextb[i]);
	  nexta = w * nextb;
	  for (i = 0; i < n; i++)
	    nexta[i] = sgn(nexta[i]);      
	  if ((nextb != b[k]) && (nexta != a[k]))
	    {
	      k += 2;
	      if (k >= P)
		k == 0;
	      bO = nextb;
	      aO = nexta;	      
	    }
	  else
	    break;
	}
      break;
    case m:
      // The vector library restricts programming around the static allocation 
      // of memory to the vector datatype.
      // To test the retreival using a vector of type "B", just uncomment the next line
      //bO = x;
      aO.Fill(0);
      while(1)
	{
	  nexta = w * bO;
	  for (i = 0; i < n; i++)
	    nexta[i] = sgn(nexta[i]);      
	  
	  nextb = wt * nexta;
	  for (i = 0; i < m; i++)
	    nextb[i] = sgn(nextb[i]);
	  if ((nextb != b[k]) && (nexta != a[k]))
	    {
	      k += 2;
	      if (k >= P)
		k == 0;
	      bO = nextb;
	      aO = nexta;	      
	    }
	  else
	    break;
	}
      break;
    }
  iprint("\nRetreived a: ", nexta);
  iprint("\nRetreived b: ", nextb);
  cout << endl << "k: " << k+1 << endl;
}
