/**********************************************************************************************
 *****************      FINAL PROJECT IN NEURAL NETWORKS -- CS 5388     ***********************
 *****************                 by: Karan M. Gupta                   ***********************
 **********************************************************************************************
 *****************        Hopfield Auto-Associative Memory Storage      ***********************
 *****************                  Lecture 8, Pg 34                    ***********************
 **********************************************************************************************/

void HAM()
{

  cout << endl << "************        Hopfield Auto-Associative Memory Storage       ************";
  cout << endl << "************                   Lecture 8, Pg 34                    ************" << endl;

  const int n = 5;                            // no. of elemnts in every pattern vector
  const int P = 3;                            // no. of bipolar n-D pattern vectors
  
  typedef CWTSVector<n> VectorX;

  int i, j, p, cycleno, k;
  bool seq[n];
  double netalpha;
  int probe = 0;  // 2
  
  /**** Results: *************************************************************************
   **** This implementation of the HAM algorithm uses the example given in the notes.
   **** The user may input different values in the vectors to test the algorithm.
   ***************************************************************************************/

  VectorX v[P];                              // 3 vector input exemplar set
  v[0][0] = 1;  v[0][1] = -1; v[0][2] = 1;  v[0][3] = -1; v[0][4] = 1;
  v[1][0] = -1; v[1][1] = 1;  v[1][2] = 1;  v[1][3] = -1; v[1][4] = -1;
  v[2][0] = 1;  v[2][1] = 1;  v[2][2] = -1; v[2][3] = 1;  v[2][4] = 1;

  char choice, c;
  for (i = 0; i < P; i++)
    {
      cout << endl << "Vector V" << i+1; 
      iprint(": ", v[i]);
    }
  cout << endl << "Probe vector: " << probe+1;
  cout << endl << "Do you want to use the default values? (y/n): ";
  cin >> choice;
  if ((choice == 'n') || (choice == 'N'))
    {
      cout << endl << "Preparing to accept values from the user...";
      cout << endl << "The original values are shown in parenthesis." << endl;
      for (i = 0; i < P; i++)
	for (j = 0; j < n; j++)
	  {
	    cout << "Enter value for V" << i+1 << " " << j << " (" << v[i][j] << "): ";
	    cin >> v[i][j];
	  }
      cout << endl << "Which is the probe vector? (" << probe+1 << "): ";
      cin >> probe;
    }

  VectorX w[n];                              // Weight Vector, W
  for (i = 0; i < n; i++)
    w[i].Fill(0);                            // init w by filling all vectors with 0
  for (p = 0; p < P; p++)
    for (i = 0; i < n; i++)
      for (j = 0; j < n; j++)
	w[j][i] += v[p][i] * v[p][j];       // perform summation for each pattern to update w
  for (i = 0; i < n; i++)                    
    w[i][i] -= P;                           // do the -pI thing
  
  VectorX vO;
  vO = v[probe];                            // define probe vector

  VectorX vk;
  cycleno = 0;
  // Keep looking through the memory till you find the correct pattern.
  while(1)
    {      
      cycleno++;
      // generate sequence of nos. for selecting the elements in the input
      for (j = 0; j < n; j++)
	seq[j] = false;
      // for the total no. of elements
      for (k = 0; k < n; k++)
	{
	  // select random element from the sequence, not selecting the same element twice
	  do
	    {
	      i = rand()%n;
	    }while(seq[i] == true);
	  seq[i] = true;
	  //cout << endl << "i = " << i;
	  // calculate the value of the kth vector
	  netalpha = 0;   
	  for (j = 0; j < n; j++)
	    netalpha = netalpha + w[i][j] * vO[j];	  
	  vk[i] = sgn(netalpha);
	}
      cout << endl << "Cycle no.: " << cycleno;
      iprint("   ", vk);
      // if correct vector has been found
      if (vk == vO)
	{
	  cout << endl << "Retreived vector no. " << probe << " correctly.";
	  break;
	}
    }  
  cout << endl << "Training Terminated." << endl;  
}

