/**********************************************************************************************
 *****************      FINAL PROJECT IN NEURAL NETWORKS -- CS 5388     ***********************
 *****************                 by: Karan M. Gupta                   ***********************
 **********************************************************************************************
 *****************  Multiclass Discrete Perceptron Training Algorithm   ***********************
 *****************                  Lecture 6, Pg 14                    ***********************
 **********************************************************************************************/

void MCDPTA()
{

  cout << endl << "************ Multiclass Discrete Perceptron Training Algorithm ************";
  cout << endl << "************                 Lecture 6, Pg 14                  ************" << endl;

  const int J = 3;                     // no. of elements in Y, W vectors
  const int P = 3;                     // no. of training patterns
  const int R = 3;                     // no. of classes
  const double Emax = 0;               // maximum error
  
  typedef CWTSVector<J> VectorY;

  int p, i, g, cycleno, j;
  double threshold = -1.0;
  double C = 1.0;
  double e, o, net;
  double d;

  /**** Results: ***************************************************************
   **** To implement this algorithm, this program uses the example given in
   **** the notes. The user may also input other values for the vectors than
   **** the ones used by default.
   ****
   **** This implementation uses a Maximum Error value of 0, to get the exact
   **** answers, because we are using a discrete activation function. The NN
   **** learns the optimum values for the weight vector in 4 cycles.
   *****************************************************************************/

  VectorY y[P];                        // array of input vectors, i.e. the input patterns
  y[0][0] = 10; y[0][1] = 2;  y[0][2] = threshold;
  y[1][0] = 2;  y[1][1] = -5; y[1][2] = threshold;
  y[2][0] = -5; y[2][1] = 5;  y[2][2] = threshold;

  VectorY w[P];                        // weight vector W
  w[0][0] = 1; w[0][1] = -2; w[0][2] = 0;
  w[1][0] = 0; w[1][1] = -1; w[1][2] = 2;
  w[2][0] = 1; w[2][1] = 3;  w[2][2] = -1;

  char choice, c;
  cout << endl << "No. of Input Patterns P (" << P << "): "; 
  cout << endl << "No. of Classes R (" << R << "): "; 
  cout << endl << "Threshold (" << threshold << "): ";
  cout << endl << "Learning Constant C (" << C << "): ";
  for (i = 0; i < P; i++)
    {
      cout << endl << "Input Vector Y" << i+1; iprint(": ", y[i]);
      cout << endl << "Weight Vector W" << i+1 << ": "; iprint(w[i]);
    }
  
  cout << endl << "Do you want to use the default values? (y/n): ";
  cin >> choice;
  if ((choice == 'n') || (choice == 'N'))
    {
      cout << endl << "Preparing to accept values from the user...";
      cout << endl << "The original values are shown in parenthesis." << endl;
      cout << endl << "Threshold (" << threshold << "): "; cin >> threshold;
      cout << endl << "Learning Constant C (" << C << "): "; cin >> C;
      for (i = 0; i < P; i++)
	for (j = 0; j < R; j++)
	  {
	    cout << "Enter value for Y" << i+1 << " " << j << " (" << y[i][j] << "): ";
	    cin >> y[i][j];
	    cout << "Enter value for w" << i+1 << " " << j << " (" << w[i][j] << "): ";
	    cin >> w[i][j];
	  }
    }

  cycleno = 0;
  e = Emax+1;
  while (e > Emax)
    {
      e = 0;
      cycleno++;
      cout << endl << "Learning Cycle No.: " << cycleno;
      // for each class
      for (i = 0; i < R; i++)
	{
	  cout << endl << "\t## Class " << i+1 << " ##";
	  // for each pattern
	  for (g = 0; g < P; g++)
	    {
	      // calculate output
	      net = w[g] * y[i];
	      o = sgn(net);
	      cout << endl << "\to" << g+1 << ": " << o;
	      // select the value of "d", i.e. the expected output
	      if (i == g)
		d = 1;
	      else
		d = -1;
	      cout << "   d = " << d;
	      // calculate new value for weight vector
	      w[g] = w[g] + ( y[i] * ( 0.5 * (d - o)) );
	      e = e + (0.5 * pow((d - o), 2));
	      cout << "   e = " << e;
	      cout << endl << w[g];
	    }
	}
    }

  cout << endl << "Training terminated: further weight adjustment unrequired." << endl;
  for (i = 0; i < P; i++)
    {
      cout << "w" << i+1 << ": "; 
      iprint(w[i], "\n"); 
    }

  cout << endl;
}
