/**********************************************************************************************
 *****************      FINAL PROJECT IN NEURAL NETWORKS -- CS 5388     ***********************
 *****************                 by: Karan M. Gupta                   ***********************
 **********************************************************************************************
 *****************     Single Discrete Perceptron Training Algorithm    ***********************
 *****************                  Lecture 5, Pg 27                    ***********************
 **********************************************************************************************/

void SDPTA()
{

  cout << endl << "************ Single Discrete Perceptron Training Algorithm ************";
  cout << endl << "************              Lecture 5, Pg 27                 ************" << endl;
  
  const int ylength = 2;                    // no. of elements in Y,W vectors 
 
  typedef CWTSVector<ylength> VectorY;

  int P = 4;                                // no. of input pattern vectors
  int nooftrainingsteps = 10;
  int i;
  int yindex;
  double threshold = 1.0;
  double C = 1.0;
  
  /**** Results: ***************************************************************
   **** To implement this algorithm, this program uses the example given in
   **** the notes. The user may also input other values for the vectors than
   **** the ones used by default.
   **** In this implementation, the program uses 10 training cycles, to learn
   **** correct values for a weight vector W. The program does that, giving
   **** the correct values of w = [3, 0.75]T.
  *****************************************************************************/

  VectorY y[P];                             // array of input vectors

  for (i = 0 ; i < P; i++)
    y[i].Fill(threshold);

  y[0][0] = 1;      // y[0][1] = threshold
  y[1][0] = -0.5;   // y[1][1] = threshold
  y[2][0] = 3;      // y[2][1] = threshold
  y[3][0] = -2;     // y[3][1] = threshold

  VectorY w, wdel, wnext;
  w[0] = -2.5; w[1] = 1.75;                 // weight vector

  double d[] = {1, -1, 1, -1};              // training values

  char choice, c;
  cout << endl << "No. of Input Patterns P (" << P << "): "; 
  cout << endl << "No. of Training Steps (" << nooftrainingsteps << "): ";
  cout << endl << "Threshold (" << threshold << "): ";
  cout << endl << "Learning Constant C (" << C << "): ";
  for (i = 0; i < P; i++)
    {
      cout << endl << "Input Vector Y" << i+1;
      iprint(": ", y[i]);
      cout << "  d" << i+1 << ": " << d[i];
    }
  cout << endl << "Weight Vector W: "; iprint(w);
  
  cout << endl << "Do you want to use the default values? (y/n): ";
  cin >> choice;
  if ((choice == 'n') || (choice == 'N'))
    {
      cout << endl << "Preparing to accept values from the user...";
      cout << endl << "The original values are shown in parenthesis." << endl;
      cout << endl << "No. of Training Steps (" << nooftrainingsteps << "): "; cin >> nooftrainingsteps;
      cout << endl << "Threshold (" << threshold << "): "; cin >> threshold;
      cout << endl << "Learning Constant C (" << C << "): "; cin >> C;
      for (i = 0; i < P; i++)
	{
	  cout << "Enter value for Y" << i+1 << " 0 (" << y[i][0] << "): ";
	  cin >> y[i][0];
	  cout << "Enter value for d" << i+1 << " (" << d[i] << "): ";
	  cin >> d[i];
	}
      cout << endl << "Enter value for w0 (" << w[0] << "): "; cin >> w[0];
      cout << endl << "Enter value for w1 (" << w[1] << "): "; cin >> w[1];
    }
      
  yindex = 0;
  for (i = 0; i < nooftrainingsteps; i++)
    {
      cout << endl << "****** Step " << i+1 << " ******" << endl;
      if (i >= P)
	{
	  yindex = i % P;
	  cout << "y" << i+1 << " = " << "y" << yindex+1 << "= "; iprint(y[yindex]);
	}
      else
	{
	  yindex = i;
	  cout << "y" << yindex+1 << ":"; iprint(y[yindex]);
	}      
      cout << endl << "d" << yindex+1 << ": " << d[yindex];
      cout << "  w" << i+1 << ": "; iprint(w); cout << endl;
      w = w + y[yindex] * (double)( (C/2) * (d[yindex] - sgn( w * y[yindex] )) );
    }
  cout << endl << "Training terminated.";
  cout << endl; iprint("Final weight values, w = ", w, "\n");

}

