/**********************************************************************************************
 *****************      FINAL PROJECT IN NEURAL NETWORKS -- CS 5388     ***********************
 *****************                 by: Karan M. Gupta                   ***********************
 **********************************************************************************************/

# include <iostream>
using namespace std;

# include "cwmtx/stat_matrix.h"
# include "cwmtx/stat_vector.h"
using namespace CwMtx;

# include <stdlib.h> // for system(), rand()
# include <math.h>   // for exp(), pow(), rint()

# include "actfns.h"
# include "SDPTA.h"
# include "MCDPTA.h"
# include "SCPTA.h"
# include "MCCPTA.h"
# include "BPN.h"
# include "HAM.h"
# include "BAM.h"
# include "KCL.h"

/********************************        MAIN         *****************************************/
int main(int argc, char* argv[])
{
  system("clear");

  char c;
  bool quit = false;
  while(quit == false)
    {
      cout << endl;
      cout << "**********************************************************************" << endl;
      cout << "**********                    MAIN MENU                     **********" << endl; 
      cout << "****                                                              ****" << endl;
      cout << "**    1. Single Discrete Perceptron Training Algorithm              **" << endl;
      cout << "**    2. Multiclass Discrete Perceptron Training Algorithm          **" << endl;
      cout << "**    3. Single Continuous Perceptron Training Algorithm            **" << endl;
      cout << "**    4. Multiclass Continuous Perceptron Training Algorithm        **" << endl;
      cout << "**    5. 2-Layer Back Propagation Network                           **" << endl;
      cout << "**    6. Hopfield Auto-Associative Memory Storage                   **" << endl;
      cout << "**    7. Bidirectional Associative Memory Storage                   **" << endl;
      cout << "**    8. Kohonen Competitive Learning                               **" << endl;
      cout << "**    Q. Quit                                                       **" << endl;
      cout << "**********************************************************************" << endl;
      cout << "      Enter Your Choice: " << flush;
      cin >> c;	  
      switch (c)
	{
	case '1': 
	  SDPTA();
	  break;
	case '2': 
	  MCDPTA();
	  break;
	case '3': 
	  SCPTA();
	  break;
	case '4': 
	  MCCPTA();
	  break;
	case '5': 
	  BPN();
	  break;
	case '6': 
	  HAM();
	  break;
	case '7': 
	  BAM();
	  break;
	case '8': 
	  KCL();
	  break;
	case 'Q': 
	  quit = true;
	  break;
	case 'q': 
	  quit = true;
	  break;
	default: 
	  cout << "      !!!!   Invalid Choice   !!!! " << endl;
	};
    }

  return 0;
}
